## libgmpada 0.0.20091124

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#  Uncomment this and set this variable if you install by hand.
#  DESTDIR=

# gnatmake can do parallel builds; we don't want make to interfere.
.NOTPARALLEL:
CPUS := $(shell getconf _NPROCESSORS_ONLN)

export LIB_NAME := gmpada
SOVERSION := 1
export LIB_DIR := .
export SONAME := lib$(LIB_NAME).so.$(SOVERSION)

build: $(SONAME) lib$(LIB_NAME).a $(LIB_NAME).gpr

$(SONAME): gmp/gmp-constants.ads
	gnatmake -j$(CPUS) --create-missing-dirs -Pbuild.gpr \
          -XLIB_KIND=dynamic -XLIB_OBJ_DIR=shared-obj -XLIB_ALI_DIR=shared-ali

lib$(LIB_NAME).a: gmp/gmp-constants.ads
	gnatmake -j$(CPUS) --create-missing-dirs -Pbuild.gpr \
          -XLIB_KIND=static -XLIB_OBJ_DIR=static-obj -XLIB_ALI_DIR=static-ali

$(LIB_NAME).gpr: $(LIB_NAME).gpr.template
	sed -e "s/\$$(DESTDIR)/$(DESTDIR)/g" $< > $@

gmp/gmp-constants.ads: generate_constants
	./$< > $@

generate_constants: LDFLAGS += -lgmp

clean: gmp/gmp-constants.ads
# gnatclean needs to see this ads to remove its objects
	$(MAKE) -C demo $@
	rm -rf \
          $(LIB_NAME).gpr gmp/gmp-constants.ads generate_constants *~ gmp/*~ \
          shared-obj shared-ali static-obj static-ali \
          $(SONAME) lib$(LIB_NAME).so lib$(LIB_NAME).a

install: build
	install -d $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME)
	install --mode=644 gmp/* $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME)
	install --mode=644 $(LIB_NAME).gpr $(DESTDIR)/usr/share/ada/adainclude
	install -d $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME)
	install --mode=444 shared-ali/* $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME)
	install --mode=644 lib$(LIB_NAME).a $(SONAME) $(DESTDIR)/usr/lib
	cd $(DESTDIR)/usr/lib && ln -s $(SONAME) lib$(LIB_NAME).so

uninstall:
	rm -rf \
          $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME) \
          $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME).gpr \
          $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME) \
          $(DESTDIR)/usr/lib/lib$(LIB_NAME).a $(DESTDIR)/usr/lib/$(SONAME) \
          $(DESTDIR)/usr/lib/lib$(LIB_NAME).so

test: gmp/gmp-constants.ads
	$(MAKE) -C demo $@

.PHONY: build clean install uninstall test


######################################################################
#  All that C stuff will be unnecessary with gprbuild’s mixed C/Ada
#  project files.  For the moment, gnatmake will embed all .o files,
#  we only have to compile them and store them in the object dir.
#####################################################################

C_OBJECTS := $(patsubst gmp/%.c,%.o,$(wildcard gmp/*.c))

$(SONAME): $(addprefix shared-obj/,$(C_OBJECTS))
lib$(LIB_NAME).a: $(addprefix static-obj/,$(C_OBJECTS))

%.o: CFLAGS += -g -O2
shared-obj/%.o: gmp/%.c | shared-obj
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC
static-obj/%.o: gmp/%.c | static-obj
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
shared-obj static-obj:
	mkdir --parents $@

=== demo/Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007,2009 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Normal users won’t need this Makefile or the devel project. See
# README file.

test:
	gnatmake -Pdevel
	./demo
clean:
	gnatclean -Pdevel
	$(RM) *~ output
.PHONY: test clean

# With something like gprmake (available until gnat-4.3), this should
# be enough to compile C files mentioned in project files. Its
# successor gprbuild should do the same.

# For those using gcc-4-4, we do it without gprmake here.
# This test should not depend on obsolete features of gnat.

# You must set here the directory containing GMP source (usually
# something like /usr/share/ada/adainclude/gmp).
GMP_SRC_DIR := ../gmp

test: gmp_macros.o
gmp_macros.o: $(GMP_SRC_DIR)/gmp_macros.c
	cc -c -fstack-check -g -gstabs+ -Wall $< -o $@
clean: c_clean
c_clean:
	rm -f gmp_macros.o
.PHONY: c_clean

=== debian/changelog ===
libgmpada (0.0.20091124-4) unstable; urgency=low

  * control: (Architectures) any like all ada packages. Closes: #568441.
    see http://lists.debian.org/debian-ada/2010/02/msg00002.html)
    (Standards-Version) Updated to 3.9.0.0, no changes needed.
    (Vcs-Mtn) Corrected URL.
  * rules: SOVERSION and LIBNAME must be exported to upstream Makefile.
  * Switch to dpkg-source 3.0 (quilt) format.
  * (*-dev): depend on gnat, ada-compiler.
    (*-dbg): suggest gnat, gnat-4.4, ada-compiler.

  [Ludovic Brenta]
  * debian/control (DM-Upload-Allowed): yes, in anticipation of the
    application for DM status.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Thu, 01 Jul 2010 00:37:10 +0200

libgmpada (0.0.20091124-3) unstable; urgency=low

  * control: made each package description different to please lintian.
    (Architectures) explained why alpha is temporarily disabled.
  * patches: separated and documented removal of -gstabs+ and -fstack-check.
    Corrected an upstream incoherency in library project template.
  * watch: added.
  * rules: lintian override for shlib-with-executable-stack
    Generated separated debhelper files: more readability, less overloadings.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 20 Jan 2010 20:00:17 +0100

libgmpada (0.0.20091124-2) unstable; urgency=low

  * Patched demo/Makefile,devel.gpr,build.gpr: removed gcc flag -gstabs+
    in favor of more portable -g (FTBFS on ia64)
  * Closes: 559084 patched demo/Makefile to remove gcc flag -fstack-check
    Eric Botcazou says: "-fstack-check is broken with GCC 4.4 on x86/x86-64
    Linux, it generates code that will easily segfault"
    (http://gcc.gnu.org/PR20548).
  * rules;control;patches;README.source: added quilt support
  * control: XS-VCS- becomes Vcs- to please lintian
    (VCS-Mtn) new
    (VCS-Browser) official address
    (Architectures) any -> arch supporting GNAT to avoid dependency FTBFS

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 16 Dec 2009 00:04:29 +0100

libgmpada (0.0.20091124-1) unstable; urgency=low

  * New upstream version. Avoids collision with libgmp package.
  * control, rules: split -dev and -dbg packages.
  * docs, examples, rules: clarified, removed command embedding unwanted
    files, avoid compressing examples,
  * README.Debian: updated, conformed to other packages.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Tue, 24 Nov 2009 01:46:21 +0100

libgmpada (0.0.20091113-1) unstable; urgency=low

  * New package. Closes: #555682.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Fri, 13 Nov 2009 16:21:34 +0100

=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), gnat, gnat-4.4, libgmp3-dev, libmpfr-dev
Standards-Version: 3.9.0.0
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
Vcs-Mtn: www.ada-france.org org.debian.libgmpada
Homepage: http://mtn-host.prjek.net/projects/libgmpada

Package: libgmpada1-dev
Architecture: any
Depends: ${misc:Depends}, gnat, gnat-4.4, ada-compiler, libgmpada1 (= ${binary:Version})
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime shared library.

Package: libgmpada1-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libgmpada1 (= ${binary:Version})
Recommends: libgmpada1-dev (= ${binary:Version})
Suggests: gnat, gnat-4.4, ada-compiler
Description: Ada binding to the GNU MultiPrecision library: debug symbols
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2010 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

##########################################
# Guess some variables from control file.
##########################################
# LIB_NAME and SOVERSION must be exported to upstream Makefile.

export LIB_NAME := $(shell sed -n -e "s/^Source: lib\(.\+\)$$/\1/p" debian/control)
ifndef LIB_NAME
  $(error Could not guess LIB_NAME from debian/control)
endif

export SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\(.\+\)-dbg$$/\1/p" debian/control)
ifndef SOVERSION
  $(error Could not guess SOVERSION from debian/control)
endif

ALIVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\(.\+\)-dev$$/\1/p" debian/control)
ifndef ALIVERSION
  $(error Could not guess ALIVERSION from debian/control)
endif

SONAME := lib$(LIB_NAME).so.$(SOVERSION)
LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
DBG_PKG := lib$(LIB_NAME)$(SOVERSION)-dbg
DEV_PKG := lib$(LIB_NAME)$(ALIVERSION)-dev
DOC_PKG := lib$(LIB_NAME)-doc

############################
# Ada Library Debian Helper
############################
# This a trick to use debhelper automation with external files,
# even if their names must match the package version.

# Each file named debian/ALDH.oldname is preprocessed and renamed
# according to these macros, before any build or install.  The
# preprocessed file is removed before any clean.
ALDH_macros := LIB_NAME ALIVERSION SOVERSION SONAME LIB_PKG DBG_PKG DEV_PKG DOC_PKG

ALDH_sed := sed $(foreach macro,$(ALDH_macros),-e s/$(macro)/$($(macro))/g)

define ALDH_template
ALDH_targets += $(2)
$(2): $(1)
	$(ALDH_sed) $(1) > $(2)
endef # ALDH_template

ALDH_targets :=
$(foreach template,$(wildcard debian/ALDH.*),\
  $(eval $(call ALDH_template,\
    $(template),\
    $(shell echo $(template) | $(ALDH_sed) -e s/ALDH.//))))

build binary binary-arch binary-indep install: $(ALDH_targets)

clean: ALDH_clean
.PHONY: ALDH_clean
ALDH_clean:
	rm -f $(ALDH_targets)

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

.PHONY: build binary binary-arch binary-indep clean install
build binary binary-arch binary-indep clean install:
	dh $@

override_dh_compress:
	dh_compress --all --exclude=.ads --exclude=.adb --exclude=Makefile --exclude=.c --exclude=.h

override_dh_strip:
	dh_strip --package=$(LIB_PKG) --dbg-package=$(DBG_PKG)
	dh_strip --remaining-packages

override_dh_installdocs:
	dh_installdocs --all --link-doc=$(LIB_PKG)

## libgmpada 0.0.20100805

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007-2010 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#  Set these variables if you install by hand.
#  DESTDIR and LIBNAME should contain no pipe character.
DESTDIR ?=
LIB_NAME ?= gmpada
SOVERSION ?= 1

# gprbuild can do parallel builds; we don't want make to interfere.
.NOTPARALLEL:
CPUS := $(shell getconf _NPROCESSORS_ONLN)

test: src/gmp-constants.ads
	gprbuild -j$(CPUS) --create-missing-dirs Makefile_test.gpr
	cd test-obj && ./demo
TO_CLEAN += test-obj

build: src/gmp-constants.ads $(LIB_NAME).gpr
	gprbuild -j$(CPUS) --create-missing-dirs Makefile_build.gpr \
          -XKIND=dynamic \
          -XNAME=$(LIB_NAME) \
          -XVERSION=lib$(LIB_NAME).so.$(SOVERSION)
	gprbuild -j$(CPUS) --create-missing-dirs Makefile_build.gpr \
          -XKIND=static \
          -XNAME=$(LIB_NAME)
TO_CLEAN += $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)))

$(LIB_NAME).gpr: template_for_installed_project
	sed \
          -e "s/\$$(LIB_NAME)/$(LIB_NAME)/g" \
          -e "s|\$$(DESTDIR)|$(DESTDIR)|g" \
          $< > $@
TO_CLEAN += $(LIB_NAME).gpr

src/gmp-constants.ads: generate_constants
	./$< > $@
TO_CLEAN += src/gmp-constants.ads

generate_constants: CFLAGS += -g -Wall -Wextra
generate_constants: LDFLAGS += -lgmp
TO_CLEAN += generate_constants

clean:
	rm -rf $(TO_CLEAN)
	find -name "*~" -delete

install: build
	install -d $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME)
	install --mode=644 src/* $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME)
	install --mode=644 $(LIB_NAME).gpr $(DESTDIR)/usr/share/ada/adainclude
	install -d $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME)
	install --mode=444 build-lib-dynamic/*.ali $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME)
	install --mode=644 build-lib-static/lib$(LIB_NAME).a $(DESTDIR)/usr/lib
	install --mode=644 build-lib-dynamic/lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/usr/lib
	cd $(DESTDIR)/usr/lib && ln -f -s lib$(LIB_NAME).so.$(SOVERSION) lib$(LIB_NAME).so

uninstall:
	rm -rf \
          $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME) \
          $(DESTDIR)/usr/share/ada/adainclude/$(LIB_NAME).gpr \
          $(DESTDIR)/usr/lib/ada/adalib/$(LIB_NAME) \
          $(DESTDIR)/usr/lib/lib$(LIB_NAME).a \
          $(DESTDIR)/usr/lib/lib$(LIB_NAME).so.$(SOVERSION) \
          $(DESTDIR)/usr/lib/lib$(LIB_NAME).so

.PHONY: build clean install uninstall test

=== debian/changelog ===
libgmpada (0.0.20100805-2) unstable; urgency=low

  * compat, control: updated to debhelper 8.
  * rules: made dh targets more generic
  * patches: LDLIBS instead of LDFLAGS (ubuntu bug770987)

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Wed, 13 Jul 2011 14:45:18 +0200

libgmpada (0.0.20100805-1) unstable; urgency=low

  * New upstream release.
  * control: (Build-Depends) upstream now uses gprbuild.
    An unversioned libgmp-dev is now available.
    (Standards-Version) 3.9.2 without changes.
    Development package renaming, Conflicts & Replaces due to debian-ada-policy.
  * copyright: updated.
  * patches: two integrated upstream, one updated.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Mon, 09 May 2011 00:25:14 +0200

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,17 @@
 Priority: extra
 Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 7.0.50~), gnat, gnat-4.4, libgmp3-dev, libmpfr-dev
-Standards-Version: 3.9.0.0
+Build-Depends: debhelper (>= 8), gnat, gnat-4.4, libgmp-dev, libmpfr-dev, gprbuild
+Standards-Version: 3.9.2
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
 Vcs-Mtn: www.ada-france.org org.debian.libgmpada
 Homepage: http://mtn-host.prjek.net/projects/libgmpada
 
-Package: libgmpada1-dev
+Package: libgmpada2-dev
 Architecture: any
 Depends: ${misc:Depends}, gnat, gnat-4.4, ada-compiler, libgmpada1 (= ${binary:Version})
+Conflicts: libgmpada1-dev
+Replaces: libgmpada1-dev
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and
@@ -37,7 +39,7 @@
 Section: debug
 Architecture: any
 Depends: ${misc:Depends}, libgmpada1 (= ${binary:Version})
-Recommends: libgmpada1-dev (= ${binary:Version})
+Recommends: libgmpada2-dev (= ${binary:Version})
 Suggests: gnat, gnat-4.4, ada-compiler
 Description: Ada binding to the GNU MultiPrecision library: debug symbols
  GMPAda allows programmers to use the GNU MultiPrecision library

=== debian/rules ===
--- 
+++ 
@@ -90,8 +90,7 @@
 # Uncomment this to turn on verbose mode.
 # export DH_VERBOSE=1
 
-.PHONY: build binary binary-arch binary-indep clean install
-build binary binary-arch binary-indep clean install:
+%:
 	dh $@
 
 override_dh_compress:

## libgmpada 0.0.20110925

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007-2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################
# Global configuration #
########################

LIB_NAME := gmpada
SOVERSION := 1

################################
# Build and test configuration #
################################

GPRBUILD_FLAGS :=

##############################
# Installation configuration #
##############################

# Each of the following path should be prefixed with
DESTDIR :=

# The sources files are installed into a $(LIB_NAME) subdirectory of
SRC_DIR := usr/share/ada/adainclude

# A $(LIB_NAME).gpr project convenient for library usage is installed into
GPR_DIR := usr/share/ada/adainclude
# The content of this file ignores DESTDIR.

# The GNAT ALI files are installed into a $(LIB_NAME) subdirectory of
ALI_DIR := usr/lib/ada/adalib

# The static and dynamic library are installed into
LIB_DIR := usr/lib

#########
# Rules #
#########

build: src/gmp-constants.ads
	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_build.gpr \
          -XKIND=dynamic \
          -XNAME=$(LIB_NAME) \
          -XVERSION=lib$(LIB_NAME).so.$(SOVERSION)
	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_build.gpr \
          -XKIND=static \
          -XNAME=$(LIB_NAME)
clean::
	rm -rf $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)))

src/gmp-constants.ads: generate_constants
	./$< > $@
clean::
	rm -f src/gmp-constants.ads

generate_constants: CFLAGS += -Wall -Wextra
generate_constants: LDLIBS += -lgmp
clean::
	rm -f generate_constants

clean::
	find -name "*~" -delete

test: src/gmp-constants.ads
	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_test.gpr
	cd test-obj && ./demo
clean::
	rm -rf test-obj

install: build
	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --mode=644 src/* $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(GPR_DIR)
	sed template_for_installed_project \
          -e "s|\$$(LIB_NAME)|$(LIB_NAME)|g" \
          -e "s|\$$(SOURCE_DIR)|/$(SRC_DIR)/$(LIB_NAME)|g" \
          -e "s|\$$(LIBRARY_ALI_DIR)|/$(ALI_DIR)/$(LIB_NAME)|g" \
          -e "s|\$$(LIBRARY_DIR)|/$(LIB_DIR)|g" \
          > $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	chmod 644 $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --mode=444 build-lib-dynamic/*.ali $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	install --directory $(DESTDIR)/$(LIB_DIR)
	install --mode=644 build-lib-static/lib$(LIB_NAME).a $(DESTDIR)/$(LIB_DIR)
	install --mode=644 build-lib-dynamic/lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)/$(LIB_DIR)
	cd $(DESTDIR)/$(LIB_DIR) && ln --force --symbolic lib$(LIB_NAME).so.$(SOVERSION) lib$(LIB_NAME).so

uninstall:
	rm -rf $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
	rm -rf $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).a
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so

.PHONY: build clean install test uninstall

=== debian/changelog ===
libgmpada (0.0.20110925-2) unstable; urgency=low

  * rules: do not strip static archive.
  * lintian-overrides: wildcard instead of an explicit architecture.
  * README.Debian: should not depend on the architecture.
  * rules: get-orig-source and run-tests targets.
  * control (Build-Depends): a gprbuild providing -R option.
  * rules: replaced ALDH subsystem by debhelper overrides for readability.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Fri, 09 Dec 2011 23:48:58 +0100

libgmpada (0.0.20110925-1) unstable; urgency=low

  * New upstream release, a patch removed.
  * Build with gcc and gnat 4.6. Closes: #642642, #633569.
  * Multi arch support for library and -dev package.
    Build-Depends: debhelper >= 8.9.8 to accept new *.ali directory.
  * Package renaming due to debian-ada-policy:
    libgmpada2-dev -> libgmpada3-dev
    libgmpada1 -> libgmpada2
    libgmpada1-dbg -> libgmpada-dbg
  * source/options: max bzip2 compression for debian.tar
  * source/local-options: abort-on-upstream-changes, unapply-patches

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Sat, 01 Oct 2011 00:02:50 +0200

=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: extra
Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
DM-Upload-Allowed: yes
Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 8.9.8),
 gnat, gnat-4.6, gprbuild (>= 2011),
 libgmp-dev, libmpfr-dev
Standards-Version: 3.9.2
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
Vcs-Mtn: www.ada-france.org org.debian.libgmpada
Homepage: http://mtn-host.prjek.net/projects/libgmpada

Package: libgmpada3-dev
Architecture: any
Depends: ${misc:Depends},
 gnat, gnat-4.6, ada-compiler,
 libgmpada2 (= ${binary:Version})
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime shared library.

Package: libgmpada-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libgmpada2 (= ${binary:Version})
Recommends: libgmpada3-dev (= ${binary:Version})
Suggests: gnat, ada-compiler
Description: Ada binding to the GNU MultiPrecision library: debug symbols
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats. Experimental support for mpfr's better float rounding is
 provided.
 .
 This package contains the runtime debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

##############
# Legal stuff
##############

# Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2009-2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
# USA

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

######################
# Set some variables #
######################

# Export CFLAGS and LDFLAGS to upstream Makefile.
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))

SOVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)$$/\1/p" debian/control)
ifndef SOVERSION
  $(warning Could not guess SOVERSION from debian/control)
endif

ALIVERSION := $(shell sed -n -e "s/^Package: lib$(LIB_NAME)\([[:digit:]]\+\)-dev$$/\1/p" debian/control)
ifndef ALIVERSION
  $(warning Could not guess ALIVERSION from debian/control)
endif

LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
DBG_PKG := lib$(LIB_NAME)-dbg
DEV_PKG := lib$(LIB_NAME)$(ALIVERSION)-dev
DOC_PKG := lib$(LIB_NAME)-doc

# -R: avoid setting run path option (aka rpath)
# -j: number of jobs
GPRBUILD_FLAGS := -R -j$(shell getconf _NPROCESSORS_ONLN)

######################
# debhelper overrides
######################

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

%:
	dh $@

# dh_clean is overriden with a double-colon rule, as it is convenient
# to add cleaning recipes close to the corresponding file creation.
override_dh_clean::
	dh_clean

override_dh_auto_build:
	dh_auto_build -- \
          LIB_NAME=$(LIB_NAME) \
          SOVERSION=$(SOVERSION) \
          GPRBUILD_FLAGS="$(GPRBUILD_FLAGS)"

override_dh_auto_test:
	dh_auto_test -- \
          LIB_NAME=$(LIB_NAME) \
          GPRBUILD_FLAGS="$(GPRBUILD_FLAGS)"

override_dh_auto_install:
	dh_auto_install -- \
          LIB_NAME=$(LIB_NAME) \
          SOVERSION=$(SOVERSION) \
          ALI_DIR=usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib \
          LIB_DIR=usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_install:
	dh_install --package=$(DEV_PKG) usr/share/ada/adainclude
	dh_install --package=$(DEV_PKG) usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib/$(LIB_NAME)
	dh_install --package=$(DEV_PKG) usr/lib/$(DEB_HOST_MULTIARCH)/lib$(LIB_NAME).a
	dh_install --package=$(LIB_PKG) usr/lib/$(DEB_HOST_MULTIARCH)/lib$(LIB_NAME).so.$(SOVERSION)
	dh_install --remaining-packages

# According to dh_installdocs(1), debian/README.Debian should be
# installed automatically, but it is not.
override_dh_installdocs:
	dh_installdocs --package=$(LIB_PKG) debian/README.Debian
	dh_installdocs --package=$(DEV_PKG) --link-doc=$(LIB_PKG) README TODO
	dh_installdocs --package=$(DBG_PKG) --link-doc=$(LIB_PKG)
	dh_installdocs --remaining-packages

override_dh_installexamples:
	dh_installexamples --package=$(DEV_PKG) demo/*
	dh_installexamples --remaining-packages

# We create the lintian override file on the fly because it has to
# contain the soversion. As we cannot mention the multiarch triplet in
# an /usr/share file, we use a wildcard.
override_dh_lintian: debian/$(LIB_PKG).lintian-overrides
	dh_lintian --remaining-packages
debian/$(LIB_PKG).lintian-overrides:
	echo "# GNAT uses trampolines to implement Ada exceptions." >> $@
	echo "$(LIB_PKG) binary: shlib-with-executable-stack usr/lib/*/lib$(LIB_NAME).so.$(SOVERSION)" >> $@
override_dh_clean::
	$(RM) debian/$(LIB_PKG).lintian-overrides

override_dh_link:
	dh_link --package=$(DEV_PKG) \
          usr/lib/$(DEB_HOST_MULTIARCH)/lib$(LIB_NAME).so.$(SOVERSION) \
          usr/lib/$(DEB_HOST_MULTIARCH)/lib$(LIB_NAME).so
	dh_link --remaining-packages

override_dh_compress:
	dh_compress --package=$(DEV_PKG) \
          --exclude=.ads \
          --exclude=.adb \
          --exclude=Makefile \
          --exclude=.c \
          --exclude=.h
	dh_compress --remaining-packages

override_dh_strip:
	dh_strip --package=$(LIB_PKG) --dbg-package=$(DBG_PKG)
	dh_strip --package=$(DEV_PKG) --exclude=.a
	dh_strip --remaining-packages

######################################################################

GET_ORIG_MTN := mtn://www.ada-france.org?net.prjek.mtn-host.libgmpada
GET_ORIG_DIR := libgmpada
GET_ORIG_TGZ := libgmpada.tgz
GET_ORIG_TMP := libgmpada-$@-XXXXXXXXXX

get-orig-source:
	TMPDIR=$$(mktemp --tmpdir --directory $(GET_ORIG_TMP)) && \
        mtn clone -d $$TMPDIR/db.mtn $(GET_ORIG_MTN) -k "" $$TMPDIR/$(GET_ORIG_DIR) && \
        (cd $$TMPDIR && tar --create --gzip --exclude="_MTN" $(GET_ORIG_DIR)) > $(GET_ORIG_TGZ) ; \
        rm -f -r $$TMPDIR
	@echo "The file $(GET_ORIG_TGZ) contains the latest Debian snapshot of upstream sources."

######################################################################

RUN_TESTS_TMP := libgmpada-run-tests-XXXXXXXXXX

run-tests:
	TMPDIR=$$(mktemp --tmpdir --directory $(RUN_TESTS_TMP)) && \
        export TMPDIR && \
        (cd $$TMPDIR && sh $(CURDIR)/debian/tests/link_with_shared); \
        if test $$? = 0; then echo ok; else echo ko; fi; \
        rm -f -r $$TMPDIR

=== debian/watch ===
version=3
opts="uversionmangle=s/^/0.0./" http://mtn-host.prjek.net/projects/libgmpada/files/libgmpada-(.*)\.tar\.gz

## libgmpada 0.0.20120318

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
-#    Copyright (C) 2007-2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+#    Copyright (C) 2007-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 #
 #    This program is free software: you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
@@ -19,13 +19,54 @@
 ########################
 
 LIB_NAME := gmpada
-SOVERSION := 1
+
+SOVERSION := $(shell sed -n 's/.*Soversion *:= *"\([[:digit:].]\+\)";.*/\1/p' $(LIB_NAME).gpr)
 
 ################################
 # Build and test configuration #
 ################################
 
-GPRBUILD_FLAGS :=
+# Default values if these variables are not set in the environment.
+# These flags are used in this Makefile as usual, in particular in the
+# implicit rule compiling generate_constants.c. Prefer overriding them
+# instead of cargs or largs..
+CFLAGS  ?= -g -O2
+LDFLAGS ?= -Wl,--as-needed
+# -g: produce debugging information
+# -O2: default optimization
+# -Wl,--as-needed: link only needed libraries
+
+# Gprbuild allows setting specific flags for each step (Compiler,
+# Binder, Linker, Gprbuild) and language.
+cargs     := $(CFLAGS)
+cargs_Ada := -gnatn -gnatw.e -gnatwH
+largs     := $(LDFLAGS)
+gargs     := -R -s -j$(shell getconf _NPROCESSORS_ONLN)
+# -gnatn: allow subprogram inlining
+# -gnatw.e: activate all optional warnings
+# -gnatwH: except hiding
+# -R: no run path option
+# -s: recompile if compilation switches have changed
+
+# Here is the exhaustive flag list.
+gpr_flag_names := \
+  cargs cargs_Ada cargs_C \
+  bargs bargs_Ada bargs_C \
+  largs largs_Ada largs_C \
+  gargs
+
+
+# Note that -gargs must come last, or else following flags will be
+# interpreted as linker flags.
+
+# Build the actual command line flags. For readability, only append
+# the non-empty variables.
+define append_gprbuild_flag
+  ifneq (,$$($(1)))
+    GPRBUILD_FLAGS += -$(subst _,:,$(1)) $$($(1))
+  endif
+endef
+$(foreach var,$(gpr_flag_names),$(eval $(call append_gprbuild_flag,$(var))))
 
 ##############################
 # Installation configuration #
@@ -51,45 +92,37 @@
 # Rules #
 #########
 
-build: src/gmp-constants.ads
-	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_build.gpr \
-          -XKIND=dynamic \
-          -XNAME=$(LIB_NAME) \
-          -XVERSION=lib$(LIB_NAME).so.$(SOVERSION)
-	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_build.gpr \
-          -XKIND=static \
-          -XNAME=$(LIB_NAME)
+build: build-dynamic build-static
+
+build-dynamic build-static: build-%: src/gmp-constants.ads
+	gprbuild $(GPRBUILD_FLAGS) $(LIB_NAME).gpr -XKIND=$*
 clean::
-	rm -rf $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)))
+	rm -f $(foreach dir,obj lib,$(foreach kind,dynamic static,build-$(dir)-$(kind)/*))
 
 src/gmp-constants.ads: generate_constants
 	./$< > $@
 clean::
 	rm -f src/gmp-constants.ads
 
-generate_constants: CFLAGS += -Wall -Wextra
-generate_constants: LDLIBS += -lgmp
+generate_constants: LDLIBS := -lgmp
 clean::
 	rm -f generate_constants
 
 clean::
 	find -name "*~" -delete
 
-test: src/gmp-constants.ads
-	gprbuild $(GPRBUILD_FLAGS) --create-missing-dirs Makefile_test.gpr
-	cd test-obj && ./demo
+test: build-static
+	gprbuild $(GPRBUILD_FLAGS) demo/demo.gpr -XKIND=static
+	demo/demo
 clean::
-	rm -rf test-obj
+	rm -f demo/demo demo/obj/*
 
 install: build
 	install --directory $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
-	install --mode=644 src/* $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
+	install --mode=644 src/*.ad[sb] src/*.[ch] $(DESTDIR)/$(SRC_DIR)/$(LIB_NAME)
 	install --directory $(DESTDIR)/$(GPR_DIR)
 	sed template_for_installed_project \
-          -e "s|\$$(LIB_NAME)|$(LIB_NAME)|g" \
-          -e "s|\$$(SOURCE_DIR)|/$(SRC_DIR)/$(LIB_NAME)|g" \
-          -e "s|\$$(LIBRARY_ALI_DIR)|/$(ALI_DIR)/$(LIB_NAME)|g" \
-          -e "s|\$$(LIBRARY_DIR)|/$(LIB_DIR)|g" \
+          $(foreach var,LIB_NAME SRC_DIR ALI_DIR LIB_DIR,-e 's|$$($(var))|$($(var))|g') \
           > $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
 	chmod 644 $(DESTDIR)/$(GPR_DIR)/$(LIB_NAME).gpr
 	install --directory $(DESTDIR)/$(ALI_DIR)/$(LIB_NAME)
@@ -107,4 +140,25 @@
 	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so.$(SOVERSION)
 	rm -f $(DESTDIR)/$(LIB_DIR)/lib$(LIB_NAME).so
 
-.PHONY: build clean install test uninstall
+# Paranoid flags for developpers.
+
+# -g: debugging information
+# -Wall: optional warnings
+# -Wextra: extra warnings
+# -fstack-check: stack overflow checking
+# -gnatf: full errors
+# -gnatq: dont’quit
+# -gnatQ: generate ALI files for cross-ref
+# -gnata: Assert and Debug pragmas
+# -gnatVa: all validity checks
+# -gnaty: all style checks
+# -gnatyM159: max line length
+# -gnato: runtime overflow checking
+# -gnatE: checks for access-before-elaboration
+# -E: exception backtraces
+devel:
+	$(MAKE) test CFLAGS="-g -O2 -Wall -Wextra -fstack-check" \
+             cargs_Ada="-gnatn -gnatw.e -gnatwH -gnatf -gnatq -gnatQ -gnata -gnatVa -gnaty -gnatyM159 -gnato -gnatE" \
+             bargs_Ada=-E
+
+.PHONY: build build-dynamic build-static clean devel install test uninstall

=== debian/changelog ===
libgmpada (0.0.20120318-1) unstable; urgency=low

  * New upstream release (only build system changes).
  * README.Debian: replaced with a short reference to policy.
  * control: debhelper 9, Standards-Version 3.9.3 (no changes)
  * rules: simplified flags transmission
  * tests: create obj dir to conform to new upstream.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Sun, 18 Mar 2012 06:18:31 +0100

libgmpada (0.0.20110925-3) unstable; urgency=low

  * control: remove dependencies on ada-compiler virtual package.

 -- Nicolas Boulenguez <nicolas.boulenguez@free.fr>  Thu, 09 Feb 2012 20:50:50 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: extra
 Maintainer: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 DM-Upload-Allowed: yes
-Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 8.9.8),
+Build-Depends: dpkg-dev (>= 1.16.1), debhelper (>= 9),
  gnat, gnat-4.6, gprbuild (>= 2011),
  libgmp-dev, libmpfr-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
 Vcs-Mtn: www.ada-france.org org.debian.libgmpada
 Homepage: http://mtn-host.prjek.net/projects/libgmpada
@@ -14,8 +14,10 @@
 Package: libgmpada3-dev
 Architecture: any
 Depends: ${misc:Depends},
- gnat, gnat-4.6, ada-compiler,
- libgmpada2 (= ${binary:Version})
+ gnat, gnat-${ada:GNAT-VERSION},
+ ${ada:LIB-PKG} (= ${binary:Version})
+Conflicts: ${ada:OLD-DEV-PKGS}
+Replaces: ${ada:OLD-DEV-PKGS}
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and
@@ -44,9 +46,9 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, libgmpada2 (= ${binary:Version})
-Recommends: libgmpada3-dev (= ${binary:Version})
-Suggests: gnat, ada-compiler
+Depends: ${misc:Depends}, ${ada:LIB-PKG} (= ${binary:Version})
+Recommends: ${ada:DEV-PKG} (= ${binary:Version})
+Suggests: gnat
 Description: Ada binding to the GNU MultiPrecision library: debug symbols
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 ##############
 
 # Copyright (c) 2003-2009 Ludovic Brenta <lbrenta@debian.org>
-# Copyright (c) 2009-2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+# Copyright (c) 2009-2012 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -29,8 +29,11 @@
 # Set some variables #
 ######################
 
-# Export CFLAGS and LDFLAGS to upstream Makefile.
-DPKG_EXPORT_BUILDFLAGS = 1
+# Magic stuff from GNU Make manual.
+comma := ,
+empty :=
+space := $(empty) $(empty)
+
 include /usr/share/dpkg/default.mk
 
 LIB_NAME := $(patsubst lib%,%,$(DEB_SOURCE))
@@ -45,14 +48,23 @@
   $(warning Could not guess ALIVERSION from debian/control)
 endif
 
+# Gnat version has to be mentioned in Build-Depends anyways.
+GNAT_VERSION := $(shell sed -n -e "s/.*gnat-\([[:digit:].]\+\),.*/\1/p" debian/control)
+ifndef GNAT_VERSION
+  $(warning Could not guess GNAT_VERSION from debian/control)
+endif
+
 LIB_PKG := lib$(LIB_NAME)$(SOVERSION)
 DBG_PKG := lib$(LIB_NAME)-dbg
 DEV_PKG := lib$(LIB_NAME)$(ALIVERSION)-dev
 DOC_PKG := lib$(LIB_NAME)-doc
 
-# -R: avoid setting run path option (aka rpath)
-# -j: number of jobs
-GPRBUILD_FLAGS := -R -j$(shell getconf _NPROCESSORS_ONLN)
+# Fill OLD_ALIVERSIONS by hand with obsolete aliversions that depends
+# on the same gnat version. See debian-ada-policy for details.
+OLD_ALIVERSIONS :=
+OLD_DEV_PKGS := \
+  $(subst $(space),$(comma) ,$(patsubst %,lib$(LIB_NAME)%-dev, \
+  $(OLD_ALIVERSIONS)))
 
 ######################
 # debhelper overrides
@@ -69,23 +81,14 @@
 override_dh_clean::
 	dh_clean
 
-override_dh_auto_build:
-	dh_auto_build -- \
-          LIB_NAME=$(LIB_NAME) \
-          SOVERSION=$(SOVERSION) \
-          GPRBUILD_FLAGS="$(GPRBUILD_FLAGS)"
-
-override_dh_auto_test:
-	dh_auto_test -- \
-          LIB_NAME=$(LIB_NAME) \
-          GPRBUILD_FLAGS="$(GPRBUILD_FLAGS)"
-
-override_dh_auto_install:
-	dh_auto_install -- \
-          LIB_NAME=$(LIB_NAME) \
-          SOVERSION=$(SOVERSION) \
-          ALI_DIR=usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib \
-          LIB_DIR=usr/lib/$(DEB_HOST_MULTIARCH)
+# CFLAGS is good for gcc, but Ada sources do not need format
+# hardening (in gprbuild options we want that Ada do not receive the
+# format hardening.
+override_dh_auto_build override_dh_auto_test override_dh_auto_install: override_%:
+	$* -- cargs="$(filter-out -Wformat% -Werror=format%,$(CFLAGS))" \
+              cargs_C="$(filter -Wformat% -Werror=format%,$(CFLAGS))" \
+              ALI_DIR=usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib \
+              LIB_DIR=usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_install:
 	dh_install --package=$(DEV_PKG) usr/share/ada/adainclude
@@ -137,6 +140,14 @@
 	dh_strip --package=$(DEV_PKG) --exclude=.a
 	dh_strip --remaining-packages
 
+override_dh_gencontrol:
+	dh_gencontrol -- $(foreach var, \
+          DEV_PKG \
+          GNAT_VERSION \
+          LIB_PKG \
+          OLD_DEV_PKGS \
+          , '-Vada:$(subst _,-,$(var))=$($(var))')
+
 ######################################################################
 
 GET_ORIG_MTN := mtn://www.ada-france.org?net.prjek.mtn-host.libgmpada
